// Damian Turczyski I5-ISI
// ZPR praca domowa MANIPULATORY strumieni

#include <ios>
#include <iostream>
#include <sstream>
#include <iomanip>
#include <math.h>

/*	Oglne informacje:

	Flagi strumieni:
      ios::skipws     = 0x0001,     // ignoruj biae znaki [P3] < tak bd oznacza, w ktrym przykadzie mona znale zastosowanie
      ios::left       = 0x0002,     // justuj do lewej [P5]
      ios::right      = 0x0004,     // justuj do prawej [P5]
      ios::internal   = 0x0008,     // justuj do rodka [P5]
      ios::dec        = 0x0010,     // wypisuj dziesitnie [P1]
      ios::oct        = 0x0020,     // wypisuj semkowo [P1]
      ios::hex        = 0x0040,     // wypisuj szesnastkowo [P1]
      ios::showbase   = 0x0080,     // pokazuj podstaw [P1]
      ios::showpoint  = 0x0100,     // pokazuj kropk dziesitn [P2]
      ios::uppercase  = 0x0200,     // wypisuj due litery w napisach [P1, P7]
      ios::showpos    = 0x0400,     // wypisuj znak + w liczbach dodatnich [P2]
      ios::scientific = 0x0800,     // notacja naukowa (wykadnicza)[P7]
      ios::fixed      = 0x1000,     // notacja zwyka [P7]
      ios::unitbuf    = 0x2000,     // nie buforuj strumienia (flush po kadym wpisywaniu)
	  ios::stdio      = 0x4000      // ustaw tryb kompatybilnoci z stdio

	Manipulatory bezparametrowe(std):
		hex, dec, oct - podstawa systemu pozycyjnego wywietlania liczb odpowiednio szesnastkowy, dziesietny, oktarny [P1]
		fixed, scientific - system odpowiednio zwyky, naukowy [P7]
		internal, left, right - wyrwnywanie	[P5]
		
		boolalpha, noboolalpha - wartosci typu bool sa wstawiane jako ich nazwy (wcz/wycz) [P6]
		showbase, noshowbase - poka, nie pokazuj baz [P1]
		uppercase, nouppercase - poka due, mae litery (np. w systemie szesnastkowym lub notacja naukowa e) [P1, P7]
		showpoint, noshowpoint - poka, nie pokazuj kropk dziesitn [P2]
		showpos, noshowpos - poka, nie pokazuj + przed liczb dodatni [P2,P5]
		skipws, noskipws - pomijaj nie pomijaj biae znaki (tab, enter, spacja) [P3]
		unitbuf, nounitbuf - czy, nie czy buforu po wpisywaniu
		
	Manipulatory wyjciowe
		flush - oprnij bufor strumienia 
		endl - koczy lini i przechodzi do nastpnej [P1-P7]
		ends - koczy napis (string) (wstawia '\0') przydatne przy zapisywaniu do pliku napisw etc.

	Manipulatory wejciowe
		ws - pomi biae znaki czekajce w buforze [P3]

	Manipulatory parametrowe
		setw(int) - szeroko wypisywanego tekstu  [P5]
		setprecision(int) - ilo miejsc rozwinicia dziesitnego  [P4]
		setfill(char) - znak wypeniajcy puste miejsce [P5]
		setiosflags(ios_base::fmtflags), resetiosflags(ios_base::fmtflags ) - ustwienie/zerowanie flagi 
		setbase(int) - ustawienie podstawy systemu pozycyjnego [P1]
		
	Inne funkcje na strumieniach:
		int width(int) - szeroko wypisywanego tekstu [P5]
		int precision(int) - ilo miejsc rozwinicia dziesitnego [P4]
		int fill(int) - znak wypeniajcy puste miejsce [P5]

*/

using namespace std;
int main(){
	// 	Funckja 
	// 		fmtflags setf ( fmtflags fmtfl );
	// 		fmtflags setf ( fmtflags fmtfl, fmtflags mask );
  
	//	Pierwsza skadnia ustawia flagi formatu strumienie wczajc flag fmtfl nie zmieniajc reszty.
	//  Druga skdnia ustawia flagi formatu strumienia ktre s wsplne dla fmtfl i maski i wycza 
	//	te ktrych bity s w masce ale nie w fmtfl.
	//  Obie zwracaj wczeniej ustawione flagi.


	cout << "  *** Przyklad 1: ***" << endl;
//	Przykad 1: (setf, unsetf, hex, basefield, uppercase, dec)
	const int x = 253;

	cout.setf(ios::hex, ios::basefield);     // ustawienie hexarnego systemu jako podstawa
	cout << x << "=" ;						
	cout.setf(ios::uppercase);				// due litery zamiast maych (w systemie hex)
	cout << x << "=" ;		
	cout << setiosflags(ios::dec) ;			// ustawienie systemu dziesitnego 
	cout << x << endl;							// wywietlenie w dwch formatach (dec to
	
	//	Funkcja
	//	void unsetf ( fmtflags mask );
	//  Wycza flage mask.
	cout.unsetf(ios::uppercase);				// powrt do maych liter
	
	cout << hex << x << "=" << dec << x << endl;									//rwnie systemy mona zmienia przez manipulatory 
	cout << showbase << setbase(16) << x << "=" << setbase (10) << 253 <<endl;	//lub manipulatorem parametryzowanym (i pokazanie bazy)

	
	cout << "  *** Przyklad 2: ***" << endl;
//	Przykad2: (showpoint, showpos)
	float one = 1.0;
	
	cout.setf(ios::showpoint | ios::showpos);			//wczenie pokazywania kropki dziesitnej oraz znaku przed liczb
	cout << "Z kropka i znakiem: "<< one << endl;
	
	cout.unsetf(ios::showpoint | ios::showpos);		//funkcja wyczajca dan flag to usetf :
	cout << "Bez kropki i znaku: " << one <<endl;
	
	cout << "  *** Przyklad 3: ***" << endl;
//	Przykad 3:	(skipws)
	char a, b;

	istringstream iss (" \n\t 12"); 
	iss >> skipws >> a >> b ;	//najpierw pominie biale znaki potem pobierze to co zostanie (biale znaki to tab, spacja i enter)
	//j.w. inny zapis iss >> ws >> a >> b ;
	cout << a << b << endl;		//to samo mona uzyska ustawiajc flag ios::skipws
	
	cout << "  *** Przyklad 4: ***" << endl;
// Przykad 4: (manipulatory z parametrami)
	const double number = 3.14159265;
	int pom = cout.precision(2); //funkcja zwraca wczeniej zadan prezycj i ustawia precyzj podan w nawiasie
	cout << number << endl;
	cout << setprecision(pom) << number << endl;	// ustawia spowrotem na to co byo przed zmian

	cout << "  *** Przyklad 5: ***" << endl;
// Przykad 5: (Oglna tabelka, fill, width, showpos)

	for(int i = 0 ; i < 7; ++i){				
																//ustawia pene wyrwnanie do prawej
		cout << right << setw(5) << setfill('_') <<i*i*10<<'\t';	//ustawia wypenienie miejsc ktre s puste znakiem _
														//szeroko zarezerwowana na nastpny wypis
		cout.fill(' ');									//wypenianie spacjami
		cout.width(10);									//szeroko ustawiona na 10 (gdy np liczba dusza - obcinanie)
		cout.setf(ios::left | ios::showpos);			//wyrwynywanie do lewej i pokazywanie znakw
		cout << (i%2?(-1):(1))*((12+i*i/6))*i*i*9%3000;	//jaka liczba (nie ma to znaczenia)
		cout.unsetf(ios::left | ios::showpos);			//wyczenie wyrwnania do lewej i pokazywanie znakw
		cout.unsetf(ios::left);							//wyczenie wyrwnania do lewej
 		cout <<" |  ";
 		cout.width(10);
 		cout.setf(ios::internal);						//znak do lewej liczba do prawej. To samo co cout<< internal;
 		cout << (i%2?(-1):(1))*((13+i*i/3))*i*i*12%3000;
		
		cout << endl;
	}
	cout.unsetf(ios::showpos | ios::showpoint);							//wyczenie pokazywania znaku

	cout << "  *** Przyklad 6: ***" << endl;
//Przykad 6: (boolalpha, noboolalpha)


	bool bul = true;
	cout << boolalpha << bul << " lub ";		//wywietlanie nazwy bool zamiast liczby
	cout << noboolalpha << bul << endl;			//zamiast napisu liczba (true - 1, false - 0)
	
	cout << "  *** Przyklad 7: ***" << endl;
//Przykad 7: (fixed, scientific, uppercase)
	const double num= 53400;
	cout << fixed << num << endl;					//wywietlanie normalnym trybem
	cout << uppercase << scientific << num << endl;	//i naukowym z duym E
	

	system("PAUSE");
}

